<?php

namespace Andy\AttachmentManager;

use XF\Mvc\Entity\Entity;

class Listener
{
	public static function threadEntityPostSave(\XF\Mvc\Entity\Entity $entity)
	{
		// check condition
		if ($entity->isChanged('message'))
		{
			// get message
			$message = $entity->message;
			
			//########################################
			// [ATTACH=full]1[/ATTACH][ATTACH=full]2[/ATTACH]
			//########################################

			// check for multiple ATTACH codes on same line
			if (preg_match_all("/\[\/ATTACH][\n]\[ATTACH/i", $message, $out, PREG_SET_ORDER))
			{
				for ($i=0;$i<count($out);$i++)
				{
					// check condition
					if (!empty($out[$i][0]))
					{
						$replaceSrc[] = '[/ATTACH]
[ATTACH';
						$replaceStr[] = '[/ATTACH]

[ATTACH';
						$newMessage = str_ireplace($replaceSrc, $replaceStr, $message);

						$data = [
							'message' => $newMessage
						];

						$entity->fastUpdate($data);
					}
				}
			}
			
			// get message
			$message = $entity->message;
			
			// unset variables
			unset($replaceSrc);
			unset($replaceStr);
			
			//########################################
			// [ATTACH=full]1[/ATTACH]
			// [ATTACH=full]2[/ATTACH]
			//########################################

			// check for mulitple ATTACH codes without line breaks
			if (preg_match_all("/\[\/ATTACH\]\[ATTACH/i", $message, $out, PREG_SET_ORDER))
			{
				for ($i=0;$i<count($out);$i++)
				{
					// check condition
					if (!empty($out[$i][0]))
					{
						$replaceSrc[] = '[/ATTACH][ATTACH';
						$replaceStr[] = '[/ATTACH]

[ATTACH';
						$newMessage = str_ireplace($replaceSrc, $replaceStr, $message);

						$data = [
							'message' => $newMessage
						];

						$entity->fastUpdate($data);
					}
				}
			}
		}
	}
}